# -*- coding: utf-8 -*-
"""
@author: T. Guyet, AGROCAMPUS-OUEST
@date: 10/2019

Script d'affichage des stations du bus de Rennes
"""

import ogr, os, sys
from osgeo.gdalconst import * # chargement des constantes : pour GA_ReadOnly

os.chdir('/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM1')
driver = ogr.GetDriverByName('ESRI Shapefile')

# ouverture du fichier d'entree
arretsBusDS = driver.Open('tco-bus-topologie-pointsarret-td.shp', GA_ReadOnly)
if arretsBusDS is None:
  print('Could not open file')
  sys.exit(1)
arretsBusLayer = arretsBusDS.GetLayer()

extent = arretsBusLayer.GetExtent()
print("extent:" + str(extent))

geomtype = arretsBusLayer.GetGeomType()
if geomtype==ogr.wkbPoint:
    print("geomtype: POINT")
elif geomtype==ogr.wkbPolygon:
    print("geomtype: POLYGONE")
elif geomtype==ogr.wkbLine:
    print("geomtype: LINE")

layerDefinition = arretsBusLayer.GetLayerDefn()
print("Name - Type")
for i in range( layerDefinition.GetFieldCount() ):
    fieldName = layerDefinition .GetFieldDefn(i) .GetName()
    fieldTypeCode = layerDefinition .GetFieldDefn(i) .GetType()
    fieldType = layerDefinition .GetFieldDefn(i) .GetFieldTypeName(fieldTypeCode)
    print(fieldName + " " + str(fieldType))


#Pour toutes les formes de la couche d'entree, faire
cnt = 0
for arretBusFeature in arretsBusLayer:
    if arretBusFeature.GetField('nomcommune')=="Betton":
        geom = arretBusFeature.GetGeometryRef()
        print("Arret N°"+ arretBusFeature.GetField("CODE")+" '" + arretBusFeature.GetField('nom') +"', localisation: ("+ \
         str(geom.GetX()) +","+ str(geom.GetY()) +").")
        cnt += 1

print("Il y a " + str(cnt) + " arrets de bus dans Rennes.")

# Fermeture des sources de donnees
arretsBusDS.Destroy()












