#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct 16 08:59:58 2019

@author: tguyet
"""

import ogr, os, sys
from osgeo.gdalconst import GA_ReadOnly # chargement des constantes : pour GA_ReadOnly

os.chdir('/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM2/EtudeTampon')
driver = ogr.GetDriverByName('ESRI Shapefile')

# ouverture du fichier d'entree
DSparcelles = driver.Open('ILOTS_SIMPLES.shp', GA_ReadOnly)
if DSparcelles is None:
  print('Could not open file')
  sys.exit(1)
parcelles = DSparcelles.GetLayer()

DScommunes = driver.Open('Cadastre/35027/COMMUNE_id.shp', GA_ReadOnly)
if DScommunes is None:
  print('Could not open file')
  sys.exit(1)
communes = DScommunes.GetLayer()

DSbatis = driver.Open('Cadastre/35027/BATIMENT_id.shp', GA_ReadOnly)
if DSbatis is None:
  print('Could not open file')
  sys.exit(1)
batis = DSbatis.GetLayer()

## Warning: il faut obligatoirement écrire en deux lignes l'opération suivante
featcomm = communes.GetFeature(0)
geomcomm = featcomm.GetGeometryRef()

parcelles.SetSpatialFilter ( geomcomm )
area=0
i=0
for p in parcelles:
    if i%100==0:
        print( str(i) + "/" + str(parcelles.GetFeatureCount()) )
    geomP = p.GetGeometryRef()
    batis.ResetReading()
    for b in batis:
        geomB = b.GetGeometryRef()
        buffer = geomB.Buffer(250)
        inter = buffer.Intersection( geomP )
        area += inter.GetArea()
    i+=1

print("intersection:", area)

# Fermeture des sources de donnees
DSparcelles.Destroy()