#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct 16 08:59:58 2019

@author: tguyet
"""

import ogr, os, sys
from osgeo.gdalconst import GA_ReadOnly # chargement des constantes : pour GA_ReadOnly


def grignoter(parcels, g):
    """
    grignote chaque parcelle de parcels avec la géométrie p
    """
    modified_parcels=[]
    for p in parcels:
        h = p.Difference(g)
        modified_parcels.append( h )
    return( modified_parcels )



def surface_perdue(codepost, distance_buffer):
    
    # ouverture du fichier d'entree
    DSparcelles = driver.Open('ILOTS_SIMPLES.shp', GA_ReadOnly)
    if DSparcelles is None:
      print('Could not open file')
      sys.exit(1)
    parcelles = DSparcelles.GetLayer()
    
    DScommunes = driver.Open('Cadastre/'+str(codepost)+'/COMMUNE_id.shp', GA_ReadOnly)
    if DScommunes is None:
      print('Could not open file')
      sys.exit(1)
    communes = DScommunes.GetLayer()
    
    DSbatis = driver.Open('Cadastre/'+str(codepost)+'/BATIMENT_id.shp', GA_ReadOnly)
    if DSbatis is None:
      print('Could not open file')
      sys.exit(1)
    batis = DSbatis.GetLayer()
    
    ## Warning: il faut obligatoirement écrire en deux lignes l'opération suivante
    featcomm = communes.GetFeature(0)
    geomcomm = featcomm.GetGeometryRef()
    
    parcelles.SetSpatialFilter ( geomcomm )
    lp =  []
    areacomm = 0
    for p in parcelles:
        geomP = p.GetGeometryRef().Clone()
        areacomm += geomP.GetArea()
        lp.append( geomP )
    
    i=0
    for b in batis:
        if i%100==0:
            print(str(i)+"/"+str(batis.GetFeatureCount()))
        geomB = b.GetGeometryRef()
        buffer = geomB.Buffer( distance_buffer )
        lp = grignoter( lp, buffer )
        i+=1
    
    
    area = 0
    for g in lp:
        area += g.GetArea()
    print(area)
    
    
    # Fermeture des sources de donnees
    DSparcelles.Destroy()
    
    return (areacomm, areacomm-area)
    


os.chdir('/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM2/EtudeTampon')
driver = ogr.GetDriverByName('ESRI Shapefile')

cp = 35027

airecommune, aireperdue = surface_perdue(cp, 150 )





    