# -*- coding: utf-8 -*-
import ogr, os, sys
from osgeo.gdalconst import * # chargement des constantes : pour GA_ReadOnly

os.chdir('.')
driver = ogr.GetDriverByName('ESRI Shapefile')

# ouverture du fichier d'entree
velosDS = driver.Open('supports-velos.shp', GA_ReadOnly)
if velosDS is None:
  print('Could not open file')
  sys.exit(1)
velosLayer = velosDS.GetLayer()

#id = input("Quel id?")
id = 507

velosLayer.SetAttributeFilter("objectid="+str(id))
feature = velosLayer.GetNextFeature()
if feature is None:
    print("grosse erreur !!")
    sys.exit(0)

print( feature.GetField("nom_voie") )
geom = feature.GetGeometryRef()

velosLayer.SetAttributeFilter("")
velosLayer.ResetReading()

feature_plusproche = None
plusCourteDistance = float("inf")
for f in velosLayer :
    if f.GetField("objectid") == feature.GetField("objectid"):
        continue
    #1. calculer la distance d entre f et feature
    geomf = f.GetGeometryRef()
    d = (geom.GetX() - geomf.GetX())**2 + (geom.GetY() - geomf.GetY())**2
    #2. regarder si d est plus petit que plusCourteDistance
    if d < plusCourteDistance:
        #3. si oui, f devient le plus proche !
        feature_plusproche = f
        plusCourteDistance = d

print(feature_plusproche.GetGeometryRef())
print(feature_plusproche.GetField("nom_voie"))












