#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 22 15:55:33 2019

@author: tguyet
"""

import gdal
import os, sys
from gdalconst import *
import numpy as np
import time

os.chdir("/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM4")
ds = gdal.Open('United_Kingdom_Ireland.2012247.terra.721.1km.tif', GA_ReadOnly)
if ds is None:
  print('Could not open image')
  sys.exit(1)

bandList=[]
for i in range(ds.RasterCount):
    band = ds.GetRasterBand(i+1)
    data = band.ReadAsArray()
    bandList.append(data)
    
img=np.array(bandList)

array = np.zeros((ds.RasterYSize, ds.RasterXSize), dtype='float32')

L=0.5
avant = time.time()
for i in range(ds.RasterXSize):
    for j in range(ds.RasterYSize):
        array[j][i] = float(1+L) * ( img[2][j][i] - img[1][j][i] ) / ( float(img[2][j][i] + img[1][j][i]) + L)
print(time.time()-avant)

avant = time.time()
array_vec = float(1+L) * ( img[2] - img[1] ) / (img[2] + img[1] + L)
print(time.time()-avant)

# Enregistrement de l ’image transformee
driver = gdal.GetDriverByName( "GTiff" )
dst = driver.Create("SAVI.tif", ds.RasterXSize, ds.RasterYSize, 1, gdal.GDT_Float32 )
if dst is None:
    print ("Error : impossible to create the file !\n")
    sys.exit (1)
    
if not ds.GetGCPProjection() is None:
    dst.SetProjection( ds.GetGCPProjection() ) # meme projections
    geotransform = ds.GetGeoTransform() # meme transformations geometriques


dst.GetRasterBand(1).WriteArray( array_vec )

#fermeture des fichiers
dst=None
ds=None




