# -*- coding: utf-8 -*-
import ogr, gdal
import matplotlib.pyplot as plt
import numpy as np

driver = ogr.GetDriverByName('ESRI Shapefile')
DS = driver.Open('49_ThorigneAnjou/Parcelles_Thorigne_2017.shp', 0)
Layer = DS.GetLayer()

dataset = gdal.Open("extract_sentinel.tif", 0 )
geotransform = dataset.GetGeoTransform()
projection = dataset.GetProjection()
data = dataset.GetRasterBand(1).ReadAsArray()

# operation un peu complexe :
driver = gdal.GetDriverByName('MEM') # In memory dataset
target_ds = driver.Create('', dataset.RasterXSize, dataset.RasterYSize, 1, gdal.GDT_UInt16)
target_ds.SetGeoTransform( geotransform )
target_ds.SetProjection( str(projection) )
gdal.RasterizeLayer( target_ds, [1], Layer, burn_values=[0], options=["ATTRIBUTE=IDN"])
labeled_pixels = target_ds.GetRasterBand(1).ReadAsArray()
#affichage du resultat
plt.imshow(labeled_pixels)

#test d'une fonctionnalite
plt.figure()
onep = (labeled_pixels==6).astype(int)
plt.imshow( onep )

#calcul des moyennes zonales
for i in range(Layer.GetFeatureCount()):
    onep = (labeled_pixels==i).astype(int)
    moy=np.sum(onep * data)/np.sum(onep)
    print("Feature "+str(i)+": "+str(moy))
