#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 22 15:55:33 2019

@author: tguyet
"""

import gdal,ogr
import os, sys
from gdalconst import GA_ReadOnly
import numpy as np

os.chdir("/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM5/Exo_Sentinel")

#####  Récupération de l'extent de la couche vectorielle
driver = ogr.GetDriverByName('ESRI Shapefile')

# ouverture du fichier d'entree
DS = driver.Open('49_ThorigneAnjou/Parcelles_Thorigne_2017.shp', GA_ReadOnly)
if DS is None:
  print('Could not open file')
  sys.exit(1)

extent = DS.GetLayer().GetExtent()
print(extent)

#### Ouverture de la couche sentinel B12
ds = gdal.Open('SENTINEL2A_20180703-105938-887_L2A_T30TXT_D_V1-8/SENTINEL2A_20180703-105938-887_L2A_T30TXT_D_V1-8_FRE_B12.tif', GA_ReadOnly)
if ds is None:
  print('Could not open image')
  sys.exit(1)
#récupération de la seule bande
band = ds.GetRasterBand(1)

### Calcul de la zone de l'image
geotransform=ds.GetGeoTransform()
originX=geotransform[0]
originY=geotransform[3]
pixelWidth=geotransform[1]
pixelHeight=geotransform[5]

xOffsetPX=int((extent[0]-originX) /pixelWidth)
yOffsetPX=int((extent[3]-originY) /pixelHeight)

xUR=int((extent[1]-originX) /pixelWidth)
yUR=int((extent[2]-originY) /pixelHeight)


array = band.ReadAsArray(xOffsetPX-1, yOffsetPX-1,\
                         xUR-xOffsetPX+1, yUR-yOffsetPX+1)
print(np.shape(array))

driver = gdal.GetDriverByName( "GTiff" )
dst_ds = driver.Create( "output.tif", array.shape[1], array.shape[0],\
                       1, gdal.GDT_Int16 )

if dst_ds is None:
  print("Error : impossible to create the file !\n")
  sys.exit(1)

print(ds.GetProjection())

# meme projections
if not ds.GetProjection() is None:
        dst_ds.SetProjection(ds.GetProjection() )
        
geotransform=ds.GetGeoTransform()
geotransform = list(geotransform)
geotransform[0]+=(xOffsetPX-1)*pixelWidth
geotransform[3]+=(yOffsetPX-1)*pixelHeight
geotransfom = tuple(geotransform)

# meme transformations geometriques
if not geotransform is None:
    dst_ds.SetGeoTransform(geotransform)

dst_ds.GetRasterBand(1).WriteArray(array)

dst_ds = None
