#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@abstract: 

@author: tguyet
@date: Thu Nov 14 18:35:15 2019
"""

import os
os.chdir("/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM6")

# import statements
from sklearn.datasets import make_blobs
import numpy as np
import matplotlib.pyplot as plt

# create blobs
data = make_blobs(n_samples=200, n_features=2, centers=4, cluster_std=1.6, random_state=50)

# create np array for data points
points = data[0]
classes = data[1]

# create scatter plot
plt.scatter(points[:,0], points[:,1], c=classes, cmap='viridis')
plt.xlim(-15,15)
plt.ylim(-15,15)


# import KMeans
from sklearn.cluster import KMeans

# create kmeans object
kmeans = KMeans(n_clusters=4)# fit kmeans object to data
kmeans.fit(points)# print location of clusters learned by kmeans object
print(kmeans.cluster_centers_)# save new clusters for chart
y_km = kmeans.fit_predict(points)

plt.scatter(points[y_km ==0,0], points[y_km == 0,1], s=100, c='red')
plt.scatter(points[y_km ==1,0], points[y_km == 1,1], s=100, c='black')
plt.scatter(points[y_km ==2,0], points[y_km == 2,1], s=100, c='blue')
plt.scatter(points[y_km ==3,0], points[y_km == 3,1], s=100, c='cyan')


from sklearn import metrics
val=metrics.adjusted_rand_score(kmeans.labels_, classes)
val=metrics.silhouette_score(points,kmeans.labels_)

### CAH

# import hierarchical clustering libraries
import scipy.cluster.hierarchy as sch
from sklearn.cluster import AgglomerativeClustering
# create dendrogram
dendrogram = sch.dendrogram(sch.linkage(points, method='ward'))# create clusters
hc = AgglomerativeClustering(n_clusters=4, affinity = 'cityblock', linkage = 'average')# save clusters for chart
y_hc = hc.fit_predict(points)

plt.figure()

plt.scatter(points[y_hc ==0,0], points[y_hc == 0,1], s=100, c='red')
plt.scatter(points[y_hc==1,0], points[y_hc == 1,1], s=100, c='black')
plt.scatter(points[y_hc ==2,0], points[y_hc == 2,1], s=100, c='blue')
plt.scatter(points[y_hc ==3,0], points[y_hc == 3,1], s=100, c='cyan')

### DBSCAN
from sklearn.cluster import DBSCAN
db = DBSCAN(eps=0.3, min_samples=10)
db.fit(points)

y_km = db.fit_predict(points)

plt.scatter(points[y_km ==0,0], points[y_km == 0,1], s=100, c='red')
plt.scatter(points[y_km ==1,0], points[y_km == 1,1], s=100, c='black')
plt.scatter(points[y_km ==2,0], points[y_km == 2,1], s=100, c='blue')
plt.scatter(points[y_km ==3,0], points[y_km == 3,1], s=100, c='cyan')

### nb clusters

# create blobs
data = make_blobs(n_samples=200, n_features=2, centers=4, cluster_std=1.6)
# create np array for data points
points = data[0]
classes = data[1]

ks=range(2,8)
sims=[]
for k in ks:
	kmeans = KMeans(n_clusters=k)# fit kmeans object to data
	kmeans.fit(points)# print location of clusters learned by kmeans object
	sim=metrics.adjusted_rand_score(kmeans.labels_, classes)
	sims.append(sim)
	
plt.plot(ks, sims)

### dimension
from sklearn.decomposition import PCA


dims=range(2,8)
sims=[]
for d in dims:
	# create blobs
	data = make_blobs(n_samples=200, n_features=d, centers=4, cluster_std=10.6)
	# create np array for data points
	points = data[0]
	classes = data[1]
	


	points= PCA(n_components=2).fit_transform(points)

	kmeans = KMeans(n_clusters=4)# fit kmeans object to data
	kmeans.fit(points)# print location of clusters learned by kmeans object
	sim=metrics.adjusted_rand_score(kmeans.labels_, classes)
	sims.append(sim)
	
plt.plot(ks, sims)


#modification du dossier par défaut

#importation des données
import pandas
fromage = pandas.read_table("fromage.txt",sep="\t",header=0,index_col=0)
#dimension des données
print(fromage.shape)
#statistiques descriptives
print(fromage.describe())
#graphique -croisement deux à deux des variables
from pandas.tools.plotting import scatter_matrix
scatter_matrix(fromage,figsize=(9,9))

#k-meanssur les données centrées et réduites
kmeans= cluster.KMeans(n_clusters=4)
kmeans.fit(fromage_cr)
#index triés des groupesidk= np.argsort(kmeans.labels_)#affichage des observations et leurs groupesprint(pandas.DataFrame(fromage.index[idk],kmeans.labels_[idk]))#distances aux centres de classes des observationsprint(kmeans.transform(fromage_cr))#correspondance avec les groupes de la CAHpandas.crosstab(groupes_cah,kmeans.labels_)