# -*- coding: utf-8 -*-
"""
@date: 2017
@author: Thomas Guyet
"""
#import des librairies
import os
os.chdir('/home/tguyet/Enseignements/2019-2020/TELENVI/ProgSIG/CM7')

import sys
import gdal
from gdalconst import GA_ReadOnly
import pandas as pd
import numpy as np
from matplotlib import pyplot as plt
from sklearn.tree import DecisionTreeClassifier
from sklearn.model_selection import cross_val_score
from sklearn.metrics import confusion_matrix 

from sklearn.neighbors import KNeighborsClassifier
from sklearn.ensemble import RandomForestClassifier
from sklearn.naive_bayes import GaussianNB
from sklearn.svm import SVC, LinearSVC
from sklearn.tree import DecisionTreeClassifier

    
dataset = gdal.Open('zone1.tif', GA_ReadOnly)
if dataset is None:
    print('Could not open image')
    sys.exit(1)

datasetcl = gdal.Open('zone1_cl.tif', GA_ReadOnly)
if datasetcl is None:
    print('Could not open image')
    sys.exit(1)
  
#recuperation des donnees sous la forme de matrices
bands=[]
for i in range(5):
    bands.append( dataset.GetRasterBand(i+1).ReadAsArray() )
#idem pour l'image classée
bands.append( datasetcl.GetRasterBand(1).ReadAsArray()  )

#creation d'un dataframe panda par tirage aléatoire d'échantillons
cols=['b1','b2','b3','b4','b5','cl']
data = np.reshape(np.dstack(bands), (dataset.RasterXSize * dataset.RasterYSize, dataset.RasterCount+1))
nbpixels = np.shape(data)[0]

results=[ [],[] ]
for nb_ech in np.logspace(1,5,10): #nombre d'échantillons
    pos_rand=np.random.randint(0, nbpixels, int(nb_ech))
    sampled_data=data[pos_rand]
    df=pd.DataFrame(sampled_data, columns=cols)
    
    for classifier in [DecisionTreeClassifier,KNeighborsClassifier,RandomForestClassifier,GaussianNB,SVC,LinearSVC]:
	    clf = classifier()
	    acc = cross_val_score(clf, df[list(['b1','b2','b3','b4','b5']) ].values, df['cl'].values )
	    print("%s mean accuracy: %0.2f (+/- %0.2f)"%(str(classifier.__name__), acc.mean(), acc.var()*2) )
    results[0].append( nb_ech )
    results[1].append( acc.mean() )
    
plt.plot(results[0],results[1])
plt.figure()

#construction du model
clf.fit(df[list(['b1','b2','b3','b4','b5']) ].values, df['cl'].values)

########### Construction d'une image classée ###########
ldata=[]
#attention, ici, il faut prendre uniquement les données de l'image satellite, pas la vérité terrain !!
ldata = np.reshape(np.dstack(bands[:-1]), (dataset.RasterXSize * dataset.RasterYSize, dataset.RasterCount))     
df = pd.DataFrame(ldata, columns=['b1','b2','b3','b4','b5'])

array = clf.predict( df )
array = array.reshape( (dataset.RasterYSize,dataset.RasterXSize) )
plt.imshow(array)