# -*- coding: utf-8 -*-

"""
@date: 2017
@author: Thomas Guyet
"""
#import des librairies
import os

import sys
import gdal
import ogr
import osr
from gdalconst import GA_ReadOnly
import pandas as pd
import numpy as np


datasetcl = gdal.Open('zone1_cl.tif', GA_ReadOnly)
if datasetcl is None:
    print('Could not open image')
    sys.exit(1)
  
#idem pour l'image classée
band = np.array(datasetcl.GetRasterBand(1).ReadAsArray())

geotransform=datasetcl.GetGeoTransform()
originX = geotransform[0]
originY = geotransform[3]
pixelWidth = geotransform[1]
pixelHeight = geotransform[5]

# creation du fichier de sortie : couche de points
driver = ogr.GetDriverByName('ESRI Shapefile')
if os.path.exists('sample.shp'):
  driver.DeleteDataSource('sample.shp')
outDS = driver.CreateDataSource('sample.shp')
if outDS is None:
  print('Could not create file')
  sys.exit(1)

srs = osr.SpatialReference()
srs.ImportFromProj4( datasetcl.GetProjectionRef() )
print(type(srs))

outLayer = outDS.CreateLayer('sample', srs=srs, geom_type=ogr.wkbPoint)
# ajout d'un attribut aux points
fieldDefn = ogr.FieldDefn('cl', ogr.OFTInteger)
outLayer.CreateField(fieldDefn)

for _ in range(1000):
    x=np.random.randint(0,datasetcl.RasterXSize)
    y=np.random.randint(0,datasetcl.RasterYSize)
    band[y,x]
    # creation d'un nouveau point
    point = ogr.Geometry(ogr.wkbPoint)
    point.AddPoint(originX+pixelWidth*x, originY+pixelHeight*y)
    
    # creation de la feature avec ses attributs associe a la forme
    featureDefn = outLayer.GetLayerDefn()
    feature = ogr.Feature(featureDefn)
    feature.SetGeometry(point)
    feature.SetField('cl', int(band[y,x]) )
    
    #ajout a la couche
    outLayer.CreateFeature(feature)
    
    #point.Destroy()
    feature.Destroy()
    
#fermeture du fichier
outLayer = None
outDS=None
