# -*- coding: utf-8 -*-
import ogr, os, sys
from osgeo.gdalconst import * # chargement des constantes : pour GA_ReadOnly

os.chdir('.')
driver = ogr.GetDriverByName('ESRI Shapefile')

# ouverture du fichier d'entree
velosDS = driver.Open('supports-velos.shp', GA_ReadOnly)
if velosDS is None:
  print('Could not open file')
  sys.exit(1)
velosLayer = velosDS.GetLayer()

cnt = 0
liste_voies = []
for velosstop in velosLayer:
    if velosstop.GetField('nom_commune')=="Rennes":
        nbsup=velosstop.GetField('nombre_supp')
        cnt += nbsup
        voie = velosstop.GetField("nom_voie")
        #print(voie)
        liste_voies.append( voie )

liste_voies = list( set(liste_voies) )
liste_voies.sort()


station= velosLayer.GetFeature(45)

print( len(liste_voies) )


print("Il y a " + str(cnt) + " supports de vélos à Rennes.")












